// Code generated by Prisma (prisma@1.19.0). DO NOT EDIT.
// Please don't change this file manually but run `prisma generate` to update it.
// For more information, please read the docs: https://www.prisma.io/docs/prisma-client/

import { DocumentNode, GraphQLSchema } from "graphql";
import { IResolvers } from "graphql-tools/dist/Interfaces";
import { makePrismaClientClass, BaseClientOptions } from "prisma-client-lib";
import { typeDefs } from "./prisma-schema";

type AtLeastOne<T, U = { [K in keyof T]: Pick<T, K> }> = Partial<T> &
  U[keyof U];

export interface Exists {
  bit: (where?: BitWhereInput) => Promise<boolean>;
  space: (where?: SpaceWhereInput) => Promise<boolean>;
  user: (where?: UserWhereInput) => Promise<boolean>;
}

export interface Node {}

export type FragmentableArray<T> = Promise<Array<T>> & Fragmentable;

export interface Fragmentable {
  $fragment<T>(fragment: string | DocumentNode): Promise<T>;
}

export interface Prisma {
  $exists: Exists;
  $graphql: <T = any>(
    query: string,
    variables?: { [key: string]: any }
  ) => Promise<T>;

  /**
   * Queries
   */

  bit: (where: BitWhereUniqueInput) => Bit;
  bits: (
    args?: {
      where?: BitWhereInput;
      orderBy?: BitOrderByInput;
      skip?: Int;
      after?: String;
      before?: String;
      first?: Int;
      last?: Int;
    }
  ) => FragmentableArray<BitNode>;
  bitsConnection: (
    args?: {
      where?: BitWhereInput;
      orderBy?: BitOrderByInput;
      skip?: Int;
      after?: String;
      before?: String;
      first?: Int;
      last?: Int;
    }
  ) => BitConnection;
  space: (where: SpaceWhereUniqueInput) => Space;
  spaces: (
    args?: {
      where?: SpaceWhereInput;
      orderBy?: SpaceOrderByInput;
      skip?: Int;
      after?: String;
      before?: String;
      first?: Int;
      last?: Int;
    }
  ) => FragmentableArray<SpaceNode>;
  spacesConnection: (
    args?: {
      where?: SpaceWhereInput;
      orderBy?: SpaceOrderByInput;
      skip?: Int;
      after?: String;
      before?: String;
      first?: Int;
      last?: Int;
    }
  ) => SpaceConnection;
  user: (where: UserWhereUniqueInput) => User;
  users: (
    args?: {
      where?: UserWhereInput;
      orderBy?: UserOrderByInput;
      skip?: Int;
      after?: String;
      before?: String;
      first?: Int;
      last?: Int;
    }
  ) => FragmentableArray<UserNode>;
  usersConnection: (
    args?: {
      where?: UserWhereInput;
      orderBy?: UserOrderByInput;
      skip?: Int;
      after?: String;
      before?: String;
      first?: Int;
      last?: Int;
    }
  ) => UserConnection;
  node: (args: { id: ID_Output }) => Node;

  /**
   * Mutations
   */

  createBit: (data: BitCreateInput) => Bit;
  updateBit: (
    args: { data: BitUpdateInput; where: BitWhereUniqueInput }
  ) => Bit;
  updateManyBits: (
    args: { data: BitUpdateInput; where?: BitWhereInput }
  ) => BatchPayload;
  upsertBit: (
    args: {
      where: BitWhereUniqueInput;
      create: BitCreateInput;
      update: BitUpdateInput;
    }
  ) => Bit;
  deleteBit: (where: BitWhereUniqueInput) => Bit;
  deleteManyBits: (where?: BitWhereInput) => BatchPayload;
  createSpace: (data: SpaceCreateInput) => Space;
  updateSpace: (
    args: { data: SpaceUpdateInput; where: SpaceWhereUniqueInput }
  ) => Space;
  updateManySpaces: (
    args: { data: SpaceUpdateInput; where?: SpaceWhereInput }
  ) => BatchPayload;
  upsertSpace: (
    args: {
      where: SpaceWhereUniqueInput;
      create: SpaceCreateInput;
      update: SpaceUpdateInput;
    }
  ) => Space;
  deleteSpace: (where: SpaceWhereUniqueInput) => Space;
  deleteManySpaces: (where?: SpaceWhereInput) => BatchPayload;
  createUser: (data: UserCreateInput) => User;
  updateUser: (
    args: { data: UserUpdateInput; where: UserWhereUniqueInput }
  ) => User;
  updateManyUsers: (
    args: { data: UserUpdateInput; where?: UserWhereInput }
  ) => BatchPayload;
  upsertUser: (
    args: {
      where: UserWhereUniqueInput;
      create: UserCreateInput;
      update: UserUpdateInput;
    }
  ) => User;
  deleteUser: (where: UserWhereUniqueInput) => User;
  deleteManyUsers: (where?: UserWhereInput) => BatchPayload;

  /**
   * Subscriptions
   */

  $subscribe: Subscription;
}

export interface Subscription {
  bit: (
    where?: BitSubscriptionWhereInput
  ) => BitSubscriptionPayloadSubscription;
  space: (
    where?: SpaceSubscriptionWhereInput
  ) => SpaceSubscriptionPayloadSubscription;
  user: (
    where?: UserSubscriptionWhereInput
  ) => UserSubscriptionPayloadSubscription;
}

export interface ClientConstructor<T> {
  new (options?: BaseClientOptions): T;
}

/**
 * Types
 */

export type BitOrderByInput =
  | "id_ASC"
  | "id_DESC"
  | "name_ASC"
  | "name_DESC"
  | "file_ASC"
  | "file_DESC"
  | "version_ASC"
  | "version_DESC"
  | "createdAt_ASC"
  | "createdAt_DESC"
  | "updatedAt_ASC"
  | "updatedAt_DESC";

export type SpaceOrderByInput =
  | "id_ASC"
  | "id_DESC"
  | "name_ASC"
  | "name_DESC"
  | "description_ASC"
  | "description_DESC"
  | "createdAt_ASC"
  | "createdAt_DESC"
  | "updatedAt_ASC"
  | "updatedAt_DESC";

export type MutationType = "CREATED" | "UPDATED" | "DELETED";

export type UserOrderByInput =
  | "id_ASC"
  | "id_DESC"
  | "email_ASC"
  | "email_DESC"
  | "password_ASC"
  | "password_DESC"
  | "createdAt_ASC"
  | "createdAt_DESC"
  | "updatedAt_ASC"
  | "updatedAt_DESC";

export type SpaceWhereUniqueInput = AtLeastOne<{
  id: ID_Input;
  name?: String;
}>;

export interface BitCreateInput {
  owner: UserCreateOneInput;
  name?: String;
  file?: String;
  version?: Float;
}

export interface BitSubscriptionWhereInput {
  mutation_in?: MutationType[] | MutationType;
  updatedFields_contains?: String;
  updatedFields_contains_every?: String[] | String;
  updatedFields_contains_some?: String[] | String;
  node?: BitWhereInput;
  AND?: BitSubscriptionWhereInput[] | BitSubscriptionWhereInput;
  OR?: BitSubscriptionWhereInput[] | BitSubscriptionWhereInput;
  NOT?: BitSubscriptionWhereInput[] | BitSubscriptionWhereInput;
}

export type BitWhereUniqueInput = AtLeastOne<{
  id: ID_Input;
}>;

export interface SpaceCreateInput {
  owner: UserCreateOneInput;
  name?: String;
  description?: String;
  bits?: BitCreateManyInput;
}

export interface UserWhereInput {
  id?: ID_Input;
  id_not?: ID_Input;
  id_in?: ID_Input[] | ID_Input;
  id_not_in?: ID_Input[] | ID_Input;
  id_lt?: ID_Input;
  id_lte?: ID_Input;
  id_gt?: ID_Input;
  id_gte?: ID_Input;
  id_contains?: ID_Input;
  id_not_contains?: ID_Input;
  id_starts_with?: ID_Input;
  id_not_starts_with?: ID_Input;
  id_ends_with?: ID_Input;
  id_not_ends_with?: ID_Input;
  email?: String;
  email_not?: String;
  email_in?: String[] | String;
  email_not_in?: String[] | String;
  email_lt?: String;
  email_lte?: String;
  email_gt?: String;
  email_gte?: String;
  email_contains?: String;
  email_not_contains?: String;
  email_starts_with?: String;
  email_not_starts_with?: String;
  email_ends_with?: String;
  email_not_ends_with?: String;
  password?: String;
  password_not?: String;
  password_in?: String[] | String;
  password_not_in?: String[] | String;
  password_lt?: String;
  password_lte?: String;
  password_gt?: String;
  password_gte?: String;
  password_contains?: String;
  password_not_contains?: String;
  password_starts_with?: String;
  password_not_starts_with?: String;
  password_ends_with?: String;
  password_not_ends_with?: String;
  AND?: UserWhereInput[] | UserWhereInput;
  OR?: UserWhereInput[] | UserWhereInput;
  NOT?: UserWhereInput[] | UserWhereInput;
}

export interface UserUpsertNestedInput {
  update: UserUpdateDataInput;
  create: UserCreateInput;
}

export interface UserUpdateInput {
  email?: String;
  password?: String;
}

export interface UserUpdateDataInput {
  email?: String;
  password?: String;
}

export interface BitUpdateDataInput {
  owner?: UserUpdateOneRequiredInput;
  name?: String;
  file?: String;
  version?: Float;
}

export type UserWhereUniqueInput = AtLeastOne<{
  id: ID_Input;
  email?: String;
}>;

export interface BitUpdateManyInput {
  create?: BitCreateInput[] | BitCreateInput;
  update?:
    | BitUpdateWithWhereUniqueNestedInput[]
    | BitUpdateWithWhereUniqueNestedInput;
  upsert?:
    | BitUpsertWithWhereUniqueNestedInput[]
    | BitUpsertWithWhereUniqueNestedInput;
  delete?: BitWhereUniqueInput[] | BitWhereUniqueInput;
  connect?: BitWhereUniqueInput[] | BitWhereUniqueInput;
  disconnect?: BitWhereUniqueInput[] | BitWhereUniqueInput;
}

export interface SpaceSubscriptionWhereInput {
  mutation_in?: MutationType[] | MutationType;
  updatedFields_contains?: String;
  updatedFields_contains_every?: String[] | String;
  updatedFields_contains_some?: String[] | String;
  node?: SpaceWhereInput;
  AND?: SpaceSubscriptionWhereInput[] | SpaceSubscriptionWhereInput;
  OR?: SpaceSubscriptionWhereInput[] | SpaceSubscriptionWhereInput;
  NOT?: SpaceSubscriptionWhereInput[] | SpaceSubscriptionWhereInput;
}

export interface UserSubscriptionWhereInput {
  mutation_in?: MutationType[] | MutationType;
  updatedFields_contains?: String;
  updatedFields_contains_every?: String[] | String;
  updatedFields_contains_some?: String[] | String;
  node?: UserWhereInput;
  AND?: UserSubscriptionWhereInput[] | UserSubscriptionWhereInput;
  OR?: UserSubscriptionWhereInput[] | UserSubscriptionWhereInput;
  NOT?: UserSubscriptionWhereInput[] | UserSubscriptionWhereInput;
}

export interface SpaceWhereInput {
  id?: ID_Input;
  id_not?: ID_Input;
  id_in?: ID_Input[] | ID_Input;
  id_not_in?: ID_Input[] | ID_Input;
  id_lt?: ID_Input;
  id_lte?: ID_Input;
  id_gt?: ID_Input;
  id_gte?: ID_Input;
  id_contains?: ID_Input;
  id_not_contains?: ID_Input;
  id_starts_with?: ID_Input;
  id_not_starts_with?: ID_Input;
  id_ends_with?: ID_Input;
  id_not_ends_with?: ID_Input;
  owner?: UserWhereInput;
  name?: String;
  name_not?: String;
  name_in?: String[] | String;
  name_not_in?: String[] | String;
  name_lt?: String;
  name_lte?: String;
  name_gt?: String;
  name_gte?: String;
  name_contains?: String;
  name_not_contains?: String;
  name_starts_with?: String;
  name_not_starts_with?: String;
  name_ends_with?: String;
  name_not_ends_with?: String;
  description?: String;
  description_not?: String;
  description_in?: String[] | String;
  description_not_in?: String[] | String;
  description_lt?: String;
  description_lte?: String;
  description_gt?: String;
  description_gte?: String;
  description_contains?: String;
  description_not_contains?: String;
  description_starts_with?: String;
  description_not_starts_with?: String;
  description_ends_with?: String;
  description_not_ends_with?: String;
  bits_every?: BitWhereInput;
  bits_some?: BitWhereInput;
  bits_none?: BitWhereInput;
  AND?: SpaceWhereInput[] | SpaceWhereInput;
  OR?: SpaceWhereInput[] | SpaceWhereInput;
  NOT?: SpaceWhereInput[] | SpaceWhereInput;
}

export interface UserCreateOneInput {
  create?: UserCreateInput;
  connect?: UserWhereUniqueInput;
}

export interface UserCreateInput {
  email: String;
  password: String;
}

export interface BitUpdateInput {
  owner?: UserUpdateOneRequiredInput;
  name?: String;
  file?: String;
  version?: Float;
}

export interface UserUpdateOneRequiredInput {
  create?: UserCreateInput;
  update?: UserUpdateDataInput;
  upsert?: UserUpsertNestedInput;
  connect?: UserWhereUniqueInput;
}

export interface BitWhereInput {
  id?: ID_Input;
  id_not?: ID_Input;
  id_in?: ID_Input[] | ID_Input;
  id_not_in?: ID_Input[] | ID_Input;
  id_lt?: ID_Input;
  id_lte?: ID_Input;
  id_gt?: ID_Input;
  id_gte?: ID_Input;
  id_contains?: ID_Input;
  id_not_contains?: ID_Input;
  id_starts_with?: ID_Input;
  id_not_starts_with?: ID_Input;
  id_ends_with?: ID_Input;
  id_not_ends_with?: ID_Input;
  owner?: UserWhereInput;
  name?: String;
  name_not?: String;
  name_in?: String[] | String;
  name_not_in?: String[] | String;
  name_lt?: String;
  name_lte?: String;
  name_gt?: String;
  name_gte?: String;
  name_contains?: String;
  name_not_contains?: String;
  name_starts_with?: String;
  name_not_starts_with?: String;
  name_ends_with?: String;
  name_not_ends_with?: String;
  file?: String;
  file_not?: String;
  file_in?: String[] | String;
  file_not_in?: String[] | String;
  file_lt?: String;
  file_lte?: String;
  file_gt?: String;
  file_gte?: String;
  file_contains?: String;
  file_not_contains?: String;
  file_starts_with?: String;
  file_not_starts_with?: String;
  file_ends_with?: String;
  file_not_ends_with?: String;
  version?: Float;
  version_not?: Float;
  version_in?: Float[] | Float;
  version_not_in?: Float[] | Float;
  version_lt?: Float;
  version_lte?: Float;
  version_gt?: Float;
  version_gte?: Float;
  AND?: BitWhereInput[] | BitWhereInput;
  OR?: BitWhereInput[] | BitWhereInput;
  NOT?: BitWhereInput[] | BitWhereInput;
}

export interface BitCreateManyInput {
  create?: BitCreateInput[] | BitCreateInput;
  connect?: BitWhereUniqueInput[] | BitWhereUniqueInput;
}

export interface SpaceUpdateInput {
  owner?: UserUpdateOneRequiredInput;
  name?: String;
  description?: String;
  bits?: BitUpdateManyInput;
}

export interface BitUpdateWithWhereUniqueNestedInput {
  where: BitWhereUniqueInput;
  data: BitUpdateDataInput;
}

export interface BitUpsertWithWhereUniqueNestedInput {
  where: BitWhereUniqueInput;
  update: BitUpdateDataInput;
  create: BitCreateInput;
}

export interface NodeNode {
  id: ID_Output;
}

export interface PageInfoNode {
  hasNextPage: Boolean;
  hasPreviousPage: Boolean;
  startCursor?: String;
  endCursor?: String;
}

export interface PageInfo extends Promise<PageInfoNode>, Fragmentable {
  hasNextPage: () => Promise<Boolean>;
  hasPreviousPage: () => Promise<Boolean>;
  startCursor: () => Promise<String>;
  endCursor: () => Promise<String>;
}

export interface PageInfoSubscription
  extends Promise<AsyncIterator<PageInfoNode>>,
    Fragmentable {
  hasNextPage: () => Promise<AsyncIterator<Boolean>>;
  hasPreviousPage: () => Promise<AsyncIterator<Boolean>>;
  startCursor: () => Promise<AsyncIterator<String>>;
  endCursor: () => Promise<AsyncIterator<String>>;
}

export interface UserPreviousValuesNode {
  id: ID_Output;
  email: String;
  password: String;
}

export interface UserPreviousValues
  extends Promise<UserPreviousValuesNode>,
    Fragmentable {
  id: () => Promise<ID_Output>;
  email: () => Promise<String>;
  password: () => Promise<String>;
}

export interface UserPreviousValuesSubscription
  extends Promise<AsyncIterator<UserPreviousValuesNode>>,
    Fragmentable {
  id: () => Promise<AsyncIterator<ID_Output>>;
  email: () => Promise<AsyncIterator<String>>;
  password: () => Promise<AsyncIterator<String>>;
}

export interface BitConnectionNode {}

export interface BitConnection
  extends Promise<BitConnectionNode>,
    Fragmentable {
  pageInfo: <T = PageInfo>() => T;
  edges: <T = FragmentableArray<BitEdgeNode>>() => T;
  aggregate: <T = AggregateBit>() => T;
}

export interface BitConnectionSubscription
  extends Promise<AsyncIterator<BitConnectionNode>>,
    Fragmentable {
  pageInfo: <T = PageInfoSubscription>() => T;
  edges: <T = Promise<AsyncIterator<BitEdgeSubscription>>>() => T;
  aggregate: <T = AggregateBitSubscription>() => T;
}

export interface UserEdgeNode {
  cursor: String;
}

export interface UserEdge extends Promise<UserEdgeNode>, Fragmentable {
  node: <T = User>() => T;
  cursor: () => Promise<String>;
}

export interface UserEdgeSubscription
  extends Promise<AsyncIterator<UserEdgeNode>>,
    Fragmentable {
  node: <T = UserSubscription>() => T;
  cursor: () => Promise<AsyncIterator<String>>;
}

export interface AggregateUserNode {
  count: Int;
}

export interface AggregateUser
  extends Promise<AggregateUserNode>,
    Fragmentable {
  count: () => Promise<Int>;
}

export interface AggregateUserSubscription
  extends Promise<AsyncIterator<AggregateUserNode>>,
    Fragmentable {
  count: () => Promise<AsyncIterator<Int>>;
}

export interface UserNode {
  id: ID_Output;
  email: String;
  password: String;
}

export interface User extends Promise<UserNode>, Fragmentable {
  id: () => Promise<ID_Output>;
  email: () => Promise<String>;
  password: () => Promise<String>;
}

export interface UserSubscription
  extends Promise<AsyncIterator<UserNode>>,
    Fragmentable {
  id: () => Promise<AsyncIterator<ID_Output>>;
  email: () => Promise<AsyncIterator<String>>;
  password: () => Promise<AsyncIterator<String>>;
}

export interface UserConnectionNode {}

export interface UserConnection
  extends Promise<UserConnectionNode>,
    Fragmentable {
  pageInfo: <T = PageInfo>() => T;
  edges: <T = FragmentableArray<UserEdgeNode>>() => T;
  aggregate: <T = AggregateUser>() => T;
}

export interface UserConnectionSubscription
  extends Promise<AsyncIterator<UserConnectionNode>>,
    Fragmentable {
  pageInfo: <T = PageInfoSubscription>() => T;
  edges: <T = Promise<AsyncIterator<UserEdgeSubscription>>>() => T;
  aggregate: <T = AggregateUserSubscription>() => T;
}

export interface AggregateSpaceNode {
  count: Int;
}

export interface AggregateSpace
  extends Promise<AggregateSpaceNode>,
    Fragmentable {
  count: () => Promise<Int>;
}

export interface AggregateSpaceSubscription
  extends Promise<AsyncIterator<AggregateSpaceNode>>,
    Fragmentable {
  count: () => Promise<AsyncIterator<Int>>;
}

export interface SpaceEdgeNode {
  cursor: String;
}

export interface SpaceEdge extends Promise<SpaceEdgeNode>, Fragmentable {
  node: <T = Space>() => T;
  cursor: () => Promise<String>;
}

export interface SpaceEdgeSubscription
  extends Promise<AsyncIterator<SpaceEdgeNode>>,
    Fragmentable {
  node: <T = SpaceSubscription>() => T;
  cursor: () => Promise<AsyncIterator<String>>;
}

export interface UserSubscriptionPayloadNode {
  mutation: MutationType;
  updatedFields?: String[];
}

export interface UserSubscriptionPayload
  extends Promise<UserSubscriptionPayloadNode>,
    Fragmentable {
  mutation: () => Promise<MutationType>;
  node: <T = User>() => T;
  updatedFields: () => Promise<String[]>;
  previousValues: <T = UserPreviousValues>() => T;
}

export interface UserSubscriptionPayloadSubscription
  extends Promise<AsyncIterator<UserSubscriptionPayloadNode>>,
    Fragmentable {
  mutation: () => Promise<AsyncIterator<MutationType>>;
  node: <T = UserSubscription>() => T;
  updatedFields: () => Promise<AsyncIterator<String[]>>;
  previousValues: <T = UserPreviousValuesSubscription>() => T;
}

export interface SpaceNode {
  id: ID_Output;
  name?: String;
  description?: String;
}

export interface Space extends Promise<SpaceNode>, Fragmentable {
  id: () => Promise<ID_Output>;
  owner: <T = User>() => T;
  name: () => Promise<String>;
  description: () => Promise<String>;
  bits: <T = FragmentableArray<BitNode>>(
    args?: {
      where?: BitWhereInput;
      orderBy?: BitOrderByInput;
      skip?: Int;
      after?: String;
      before?: String;
      first?: Int;
      last?: Int;
    }
  ) => T;
}

export interface SpaceSubscription
  extends Promise<AsyncIterator<SpaceNode>>,
    Fragmentable {
  id: () => Promise<AsyncIterator<ID_Output>>;
  owner: <T = UserSubscription>() => T;
  name: () => Promise<AsyncIterator<String>>;
  description: () => Promise<AsyncIterator<String>>;
  bits: <T = Promise<AsyncIterator<BitSubscription>>>(
    args?: {
      where?: BitWhereInput;
      orderBy?: BitOrderByInput;
      skip?: Int;
      after?: String;
      before?: String;
      first?: Int;
      last?: Int;
    }
  ) => T;
}

export interface BitPreviousValuesNode {
  id: ID_Output;
  name?: String;
  file?: String;
  version?: Float;
}

export interface BitPreviousValues
  extends Promise<BitPreviousValuesNode>,
    Fragmentable {
  id: () => Promise<ID_Output>;
  name: () => Promise<String>;
  file: () => Promise<String>;
  version: () => Promise<Float>;
}

export interface BitPreviousValuesSubscription
  extends Promise<AsyncIterator<BitPreviousValuesNode>>,
    Fragmentable {
  id: () => Promise<AsyncIterator<ID_Output>>;
  name: () => Promise<AsyncIterator<String>>;
  file: () => Promise<AsyncIterator<String>>;
  version: () => Promise<AsyncIterator<Float>>;
}

export interface BitSubscriptionPayloadNode {
  mutation: MutationType;
  updatedFields?: String[];
}

export interface BitSubscriptionPayload
  extends Promise<BitSubscriptionPayloadNode>,
    Fragmentable {
  mutation: () => Promise<MutationType>;
  node: <T = Bit>() => T;
  updatedFields: () => Promise<String[]>;
  previousValues: <T = BitPreviousValues>() => T;
}

export interface BitSubscriptionPayloadSubscription
  extends Promise<AsyncIterator<BitSubscriptionPayloadNode>>,
    Fragmentable {
  mutation: () => Promise<AsyncIterator<MutationType>>;
  node: <T = BitSubscription>() => T;
  updatedFields: () => Promise<AsyncIterator<String[]>>;
  previousValues: <T = BitPreviousValuesSubscription>() => T;
}

export interface SpaceSubscriptionPayloadNode {
  mutation: MutationType;
  updatedFields?: String[];
}

export interface SpaceSubscriptionPayload
  extends Promise<SpaceSubscriptionPayloadNode>,
    Fragmentable {
  mutation: () => Promise<MutationType>;
  node: <T = Space>() => T;
  updatedFields: () => Promise<String[]>;
  previousValues: <T = SpacePreviousValues>() => T;
}

export interface SpaceSubscriptionPayloadSubscription
  extends Promise<AsyncIterator<SpaceSubscriptionPayloadNode>>,
    Fragmentable {
  mutation: () => Promise<AsyncIterator<MutationType>>;
  node: <T = SpaceSubscription>() => T;
  updatedFields: () => Promise<AsyncIterator<String[]>>;
  previousValues: <T = SpacePreviousValuesSubscription>() => T;
}

export interface SpacePreviousValuesNode {
  id: ID_Output;
  name?: String;
  description?: String;
}

export interface SpacePreviousValues
  extends Promise<SpacePreviousValuesNode>,
    Fragmentable {
  id: () => Promise<ID_Output>;
  name: () => Promise<String>;
  description: () => Promise<String>;
}

export interface SpacePreviousValuesSubscription
  extends Promise<AsyncIterator<SpacePreviousValuesNode>>,
    Fragmentable {
  id: () => Promise<AsyncIterator<ID_Output>>;
  name: () => Promise<AsyncIterator<String>>;
  description: () => Promise<AsyncIterator<String>>;
}

export interface AggregateBitNode {
  count: Int;
}

export interface AggregateBit extends Promise<AggregateBitNode>, Fragmentable {
  count: () => Promise<Int>;
}

export interface AggregateBitSubscription
  extends Promise<AsyncIterator<AggregateBitNode>>,
    Fragmentable {
  count: () => Promise<AsyncIterator<Int>>;
}

export interface SpaceConnectionNode {}

export interface SpaceConnection
  extends Promise<SpaceConnectionNode>,
    Fragmentable {
  pageInfo: <T = PageInfo>() => T;
  edges: <T = FragmentableArray<SpaceEdgeNode>>() => T;
  aggregate: <T = AggregateSpace>() => T;
}

export interface SpaceConnectionSubscription
  extends Promise<AsyncIterator<SpaceConnectionNode>>,
    Fragmentable {
  pageInfo: <T = PageInfoSubscription>() => T;
  edges: <T = Promise<AsyncIterator<SpaceEdgeSubscription>>>() => T;
  aggregate: <T = AggregateSpaceSubscription>() => T;
}

export interface BatchPayloadNode {
  count: Long;
}

export interface BatchPayload extends Promise<BatchPayloadNode>, Fragmentable {
  count: () => Promise<Long>;
}

export interface BatchPayloadSubscription
  extends Promise<AsyncIterator<BatchPayloadNode>>,
    Fragmentable {
  count: () => Promise<AsyncIterator<Long>>;
}

export interface BitNode {
  id: ID_Output;
  name?: String;
  file?: String;
  version?: Float;
}

export interface Bit extends Promise<BitNode>, Fragmentable {
  id: () => Promise<ID_Output>;
  owner: <T = User>() => T;
  name: () => Promise<String>;
  file: () => Promise<String>;
  version: () => Promise<Float>;
}

export interface BitSubscription
  extends Promise<AsyncIterator<BitNode>>,
    Fragmentable {
  id: () => Promise<AsyncIterator<ID_Output>>;
  owner: <T = UserSubscription>() => T;
  name: () => Promise<AsyncIterator<String>>;
  file: () => Promise<AsyncIterator<String>>;
  version: () => Promise<AsyncIterator<Float>>;
}

export interface BitEdgeNode {
  cursor: String;
}

export interface BitEdge extends Promise<BitEdgeNode>, Fragmentable {
  node: <T = Bit>() => T;
  cursor: () => Promise<String>;
}

export interface BitEdgeSubscription
  extends Promise<AsyncIterator<BitEdgeNode>>,
    Fragmentable {
  node: <T = BitSubscription>() => T;
  cursor: () => Promise<AsyncIterator<String>>;
}

/*
The `Int` scalar type represents non-fractional signed whole numeric values. Int can represent values between -(2^31) and 2^31 - 1. 
*/
export type Int = number;

/*
The `ID` scalar type represents a unique identifier, often used to refetch an object or as key for a cache. The ID type appears in a JSON response as a String; however, it is not intended to be human-readable. When expected as an input type, any string (such as `"4"`) or integer (such as `4`) input value will be accepted as an ID.
*/
export type ID_Input = string | number;
export type ID_Output = string;

export type Long = string;

/*
The `Boolean` scalar type represents `true` or `false`.
*/
export type Boolean = boolean;

/*
The `Float` scalar type represents signed double-precision fractional values as specified by [IEEE 754](http://en.wikipedia.org/wiki/IEEE_floating_point). 
*/
export type Float = number;

/*
The `String` scalar type represents textual data, represented as UTF-8 character sequences. The String type is most often used by GraphQL to represent free-form human-readable text.
*/
export type String = string;

/**
 * Type Defs
 */

export const prisma: Prisma;
